<?php


namespace App\Services\Api\Crop;


class Crop104Service implements CropService
{
    private $apiUrl = 'https://www.104.com.tw/company/ajax';
    public function search($name)
    {
        $urlName = urlencode($name);
        $searchResult = \Curl::to("{$this->apiUrl}/list?keyword=$urlName")
            ->withHeader('Referer:https://www.104.com.tw')
            ->get();
        $searchResultArray = json_decode($searchResult, true);
        $data = $searchResultArray['data'];
        $collect = collect($data);
        $filteredCollect = $collect->where('name', $name);
        if ($filteredCollect->count() === 1) {
            $hit = $filteredCollect->first();
            $hit['jobs'] = $this->jobList($hit['encodedCustNo']);
            return $hit;
        }
        return $collect;
    }
    public function jobList($encodedCustNo)
    {
        $listResult = \Curl::to("{$this->apiUrl}/joblist/$encodedCustNo?page=1&pageSize=100")
            ->withHeader('Referer:https://www.104.com.tw')
            ->get();
        $listResultArray = json_decode($listResult, true);
        $totalPages = $listResultArray['data']['totalPages'];
        $result = [];
        $result[0] = \Arr::get($listResultArray, 'data.list.topJobs');
        $result[1] = \Arr::get($listResultArray, 'data.list.normalJobs');
        if ($totalPages > 1) {
            $result = array_merge($result, $this->getJobPages("{$this->apiUrl}/joblist/$encodedCustNo?pageSize=100&page=", $totalPages));
        }
        $result = array_merge(...$result);
        $result = array_combine(\Arr::pluck($result, 'encodedJobNo'), $result);
        return $result;
    }
    public function getJobPages($baseUrl, $end, $start = 2)
    {
        $mh = curl_multi_init();
        $curls = [];
        $result = [];
        foreach (range($start, $end) as $page) {
            $headers = [
                'Referer:https://www.104.com.tw',
            ];
            $apiUrl = "$baseUrl$page";
            $handle = curl_init($apiUrl);
            curl_setopt($handle, CURLOPT_HTTPHEADER, $headers);
            curl_setopt($handle, CURLOPT_RETURNTRANSFER, true);
            curl_multi_add_handle($mh, $handle);
            $curls[$page] = $handle;
        }
        $running=null;
        do {
            curl_multi_exec($mh,$running);
        } while ($running > 0);
        foreach($curls as $page => $curl)
        {
            $content = curl_multi_getcontent($curl);
            $contentArray = json_decode($content, true);
            $result[$page] = \Arr::get($contentArray, 'data.list.normalJobs');
            curl_multi_remove_handle($mh, $curl);
        }
        curl_multi_close($mh);
        return $result;
    }
}
